<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>userDetail</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body>
    <div class="container w-50">
        <div class="text-center m-3">
            <h3>THÔNG TIN CHI TIẾT NGƯỜI DÙNG</h3>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-user-id">Nhập Id của user <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-5">
                <input id="input-user-id" placeholder="Nhập id user ..." class="form-control">
            </div>
            <div class="col-sm-3">
                <button class="btn btn-primary" onclick="onBtnLayThongTinClick()">Lấy thông tin</button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">Một số id user đúng để test: <span class="text-danger">176332, 176337, 176370,
                    176371, 176372, 176374, 176375</span></div>
        </div>

        <hr>

        <div class="row form-group mt-4">
            <label class="col-form-label col-sm-4" for="input-firstname">First name <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input id="input-firstname" placeholder="Họ và chữ lót" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-lastname">Last name <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input id="input-lastname" placeholder="Tên" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-subject">Subject <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input type="text" id="input-subject" placeholder="Chủ đề" class="form-control">
            </div>
        </div>

        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-country">Country</label>
            <div class="col-sm-8">
                <select id="select-country" class="form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="AUS">Australia</option>
                    <option value="USA">USA</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>

        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-customer-type">Customer Type</label>
            <div class="col-sm-8">
                <select id="select-customer-type" class="form-control">
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                    <option value="Standard">Standard</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-register-status">Register Status</label>
            <div class="col-sm-8">
                <select id="select-register-status" class="form-control">
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                    <option value="New">New</option>
                </select>
            </div>
        </div>
        <div class="col-sm-3">
            <button class="btn btn-primary" onclick="onBtnCapNhatUserClick()">Cập nhật User</button>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // trạng thái của server trả về, 200 = tìm thấy thành công!
    const gREQUEST_STATUS_FINISH_AND_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnLayThongTinClick() {
        var vUserIdObj = {
            userId: ""
        }

        //B1 Thu thập dữ liệu
        thuThapDuLieu(vUserIdObj);
        //B2 Kiểm tra dữ liệu
        var vDuLieuHopLe = kiemTraDuLieu(vUserIdObj);
        if (vDuLieuHopLe) {
            var vXmlHttp = new XMLHttpRequest();
            goiApiKiemTraIdUser(vUserIdObj, vXmlHttp);
            xuLyHienThi(vXmlHttp);
            // hienThiDuLieuLenWeb(vXmlHttp);
        }
        //gọi api kiểm tra thông tin

        //xử lý hiển thị
    }
    function onBtnCapNhatUserClick() {
        var vUserDataObj = {
            userId: "",
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: "",
        }
        //B1 Thu thập dữ liệu trên form lưu vào Obj
        thuThapDuLieuUser(vUserDataObj);
        //B2 Kiểm tra dữ liệu thu thập được
        var vDuLieuHopLe = kiemTraDuLieuUser(vUserDataObj);
        if (vDuLieuHopLe) {
            var vXmlHttp = new XMLHttpRequest();
            goiApiCapNhatUser(vUserDataObj, vXmlHttp);
            vXmlHttp.onreadystatechange = function () {
                
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_FINISH_AND_OK) {
                    alert("Cập nhật thành công");
                    xuLyHienThiCapNhatUser(vXmlHttp);
                }
                if(this.readyState != gREQUEST_READY_STATUS_FINISH_AND_OK || this.status != gREQUEST_STATUS_FINISH_AND_OK){
                    alert("Cập nhật không thành công")
                }
            }
        }
    }


    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function thuThapDuLieu(paramUserIdObj) {
        var vInputUserId = document.getElementById("input-user-id");
        paramUserIdObj.userId = vInputUserId.value.trim();
    }
    function kiemTraDuLieu(paramUserIdObj) {
        if (isNaN(paramUserIdObj.userId)) {
            alert("Id phải là số!");
            return false;
        }
        if (paramUserIdObj.userId == "") {
            alert("Chưa nhập ID!");
            return false;
        }
        return true;
    }
    function goiApiKiemTraIdUser(paramUserIdObj, paramXmlHttpObj) {
        paramXmlHttpObj.open("GET", "http://203.171.20.210:8080/crud-api/users/" + paramUserIdObj.userId, false);
        paramXmlHttpObj.send();
    }
    function xuLyHienThi(paramXmlHttpObj) {
        var vIdStatus = paramXmlHttpObj.status;
        if (vIdStatus == gREQUEST_STATUS_FINISH_AND_OK) {

            console.log(paramXmlHttpObj.responseText);

            var vUserIdResponse = JSON.parse(paramXmlHttpObj.responseText);
            var vInputFirstName = document.getElementById("input-firstname");
            var vInputLastName = document.getElementById("input-lastname");
            var vInputSubject = document.getElementById("input-subject");
            var vSelectCountry = document.getElementById("select-country");
            var vSelectCustomerType = document.getElementById("select-customer-type");
            var vSelectRegisterStatus = document.getElementById("select-register-status");
            vInputFirstName.value = vUserIdResponse.firstname
            vInputLastName.value = vUserIdResponse.lastname;
            vInputSubject.value = vUserIdResponse.subject;
            vSelectCountry.value = vUserIdResponse.country;
            vSelectCustomerType.value = vUserIdResponse.customerType;
            vSelectRegisterStatus.value = vUserIdResponse.registerStatus;
        }
        else {
            alert("Không tồn tại User với Id đã nhập!")
        }
    }
    //Hàm thu thập dữ liệu
    function thuThapDuLieuUser(paramUserDataObj) {
        var vInputUserId = document.getElementById("input-user-id");
        var vInputFirstName = document.getElementById("input-firstname");
        var vInputLastName = document.getElementById("input-lastname");
        var vInputSubject = document.getElementById("input-subject");
        var vSelectCountry = document.getElementById("select-country");
        var vSelectCustomerType = document.getElementById("select-customer-type");
        var vSelectRegisterStatus = document.getElementById("select-register-status");
        paramUserDataObj.userId = vInputUserId.value.trim();
        paramUserDataObj.firstname = vInputFirstName.value.trim();
        paramUserDataObj.lastname = vInputLastName.value.trim();
        paramUserDataObj.subject = vInputSubject.value.trim();
        paramUserDataObj.country = vSelectCountry.value.trim();
        paramUserDataObj.customerType = vSelectCustomerType.value.trim();
        paramUserDataObj.registerStatus = vSelectRegisterStatus.value.trim();
    }
    function kiemTraDuLieuUser(paramUserDataObj) {
        if (paramUserDataObj.firstname == "") {
            alert("Firstname chưa được nhập");
            return false;
        }
        if (paramUserDataObj.lastname == "") {
            alert("Lastname chưa được nhập");
            return false;
        }
        if (paramUserDataObj.subject == "") {
            alert("Subject chưa được nhập");
            return false;
        }
        if (paramUserDataObj.country == "") {
            alert("Country chưa được nhập");
            return false;
        }
        if (paramUserDataObj.customerType == "") {
            alert("Customer Type chưa được nhập");
            return false;
        }
        if (paramUserDataObj.registerStatus == "") {
            alert("Register Status chưa được nhập");
            return false;
        }
        return true;
    }
    function goiApiCapNhatUser(paramUserDataObj, paramXmlHttpObj) {

        var vUserJsonData = JSON.stringify(paramUserDataObj);
        // mở và gửi request đi
        
        paramXmlHttpObj.open("PUT", gBASE_URL + paramUserDataObj.userId, true);
        paramXmlHttpObj.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlHttpObj.send(vUserJsonData);
    }
    function xuLyHienThiCapNhatUser(paramXmlHttpObj){
        console.log(paramXmlHttpObj.responseText);
       
        var vResponse = JSON.parse(paramXmlHttpObj.responseText);
            // sample:  response = JSON.parse(`{"voucher":{"id":12,"maVoucher":"86423","phanTramGiamGia":"20","ghiChu":null,"ngayTao":1614361849000,"ngayCapNhat":1614361849000},"dice":4,"prize":"Xe máy"}`);
            // get result dice
            var vUserReady = vResponse.id;
            console.log("userId result:= " + vUserReady);
            

    }

</script>

</html>